root_path = File.dirname(__FILE__)
require "socket"
require "#{root_path}/common"

class Builder
	include MefabCommon
	def initialize(host, port)
		log :info, "#{self.class}: starting"
		@host, @port = host, port
	end
	def connect
		begin
			@socket = TCPSocket.new(@host, @port)
			log :info, "#{self.class}: connection established to #{@host}:#{@port}"
		rescue Exception => e
			log :fatal, "#{self.class}: couldn't connect to #{@host}:#{@port}"
			log :fatal, "#{self.class}: #{e}"
			log :info, "#{self.class}: sleeping for 60 seconds then retrying"
			sleep 60
			retry
		end
		return self
	end
	def disconnect
		send(:disconnect)
		@socket.close
		log :info, "#{self.class}: quitting"
	end
	def start
		Thread.start(@socket) do |ssocket|
			while line = ssocket.gets
				handle(line, ssocket)
			end
		end
		return self
	end
end
