root_path = File.dirname(__FILE__)
require "socket"
require "#{root_path}/common"


Thread.abort_on_exception=true

class ControlDaemon
	include MefabCommon
	def initialize(address, port)
		log :info, "#{self.class}: starting"
		@address, @port = address, port
		@threads = {}
		add_handler "DISCONNECTED:" do |params,from|
			@threads.delete_if { |s,t| not t.alive? }
			from.close
			Thread.exit
		end
	end
	def listen
		begin
			@server = TCPServer.new(@address, @port)
			log :info, "#{self.class}: listening on #{@address}:#{@port}"
		rescue Exception => e
			log :fatal, "#{self.class}: couldn't listen on #{@address}:#{@port}"
			log :fatal, "#{self.class}: #{e}"
			exit 1
		end
		return self
	end
	def stop
		#TODO SEND TO BUILDERS
		@server.close
		log :info, "#{self.class}: stopping"
		return self
	end
	def start
		log :info, "#{self.class}: waiting for connections"
		while (sock = @server.accept)
			@threads[sock] = Thread.start(sock) do |ssocket|
				log :info, "#{self.class}: new Builder handling thread started"
				while line = ssocket.gets
					log :debug, "#{self.class}: #{line.inspect} received"
					handle(line,ssocket)
				end
			end
		end
	end
end
